;-----------------------------------------------------------;
;                                                           ;
; Alien Breed IV: Final Assault                             ;
; Header File                                               ;
;                                                           ;
;-----------------------------------------------------------;

LEVEL_HEADER_LENGTH     = 16
LEVEL_SIZE              = 32*32+LEVEL_HEADER_LENGTH

;------------------------------------------------
; TI-83 Ion Header
;------------------------------------------------
#ifdef TI83                                     ; TI-83 Ion header
#define ION
#include "ion.inc"                              ; Ion include file

vars                    = saferam2
#define vars2             ti83Vars
videoBuffer             = saferam1
videoCenterCopy         = ionFastCopy

MEM_NEEDED              = LEVEL_SIZE+9
tmpProg                 = vars+512
#define GETTEMP(xx) ld xx,(tmpProg)

#define MOVE9() rst 20h

.org    progstart
        ret
        jr      nc,start
.db     " Alien Breed IV: Final Assault",0
#endif

;------------------------------------------------
; TI-83+ Ion Header
;------------------------------------------------
#ifdef TI83P
#define ION
#define PLUS
#include "ion.inc"                              ; Ion include file

vars                    = appBackupScreen
vars2                   = appBackupScreen+514
videoBuffer             = saferam1
_enoughMem              = _enoughRAM
videoCenterCopy         = ionFastCopy

MEM_NEEDED              = LEVEL_SIZE
tmpProg                 = vars+512
#define GETTEMP(xx) ld xx,(tmpProg)

#define MOVE9() rst 20h

.org    progstart-2
.db     $BB, $6D                                ; AsmPrgm token
        ret                                     ; TI-OS can't run program
        jr      nc,start                        ; Jump to start of program
.db     " Alien Breed IV: Final Assault",0      ; Description
#endif

;------------------------------------------------
; TI-83+ MirageOS Header
;------------------------------------------------
#ifdef MIRAGE                                   ; MirageOS header
#define PLUS
#include "ti83plus.inc"                         ; TI-83+ include file
#include "mirage.inc"                           ; MirageOS include file

vars                    = appBackupScreen
vars2                   = appBackupScreen+512
videoBuffer             = saferam1
vat                     = progptr
ionFastCopy             = iFastCopy
ionDetect               = iDetect
ionGetPixel             = iGetPix
ionRandom               = iRandom
videoCenterCopy         = ionFastCopy

MEM_NEEDED              = LEVEL_SIZE
tmpProg                 = vars+512
#define GETTEMP(xx) ld xx,(tmpProg)

#define MOVE9() rst 20h
#define bcallnc(xxxx)   jr  c,$+5   \ rst 28h \ .dw xxxx

.org    $9D93                                   ; progstart-2
.db     $BB, $6D                                ; AsmPrgm token
        ret                                     ; TI-OS can't run program
.db     1                                       ; MirageOS identifier
.db %00000000, %00000000                        ; Program Image
.db %01111111, %11111100
.db %01000000, %00000100
.db %01000000, %00000100
.db %01001011, %10100100
.db %01000111, %11000100
.db %01000111, %11000100
.db %01001011, %10100100
.db %01000011, %10000100
.db %01000101, %01000100
.db %01000001, %00000100
.db %01000010, %00000100
.db %01000000, %00000100
.db %01111111, %11111100
.db %00000000, %00000000

.db     "AB IV: Final Assault",0                ; Description
#endif

;------------------------------------------------
; TI-86 Header
;------------------------------------------------
#ifdef TI86                                     ; TI-83 header
#define equ .equ
#include "ti86.inc"

vars                    = $8400
vars2                   = $8500
videoBuffer             = $8600
sgrflags                = new_grf_flgs
gbuf                    = _plotsscreen
pencol                  = _pencol
videoMem                = $FC00
_getcsc                 = _get_key
currow                  = _currow
_clrscrnfull            = _clrscrn

tempMem                 = $8B00
#define GETTEMP(xx) ld xx,tempMem

dataFileStorage         = $9000
tempProgStorage         = $A500
TEMP_SIZE               = 6600
realFilePtr             = dataFileStorage - 3

#define bcall(xxxx) call xxxx

#define DIRECTIN_8586
#define GETKEY_8586
#define SPRITE_86

.org    _asm_exec_ram                           ; Where to start in memory
        nop                                     ; Identifier for shells
        jp      start                           ; Jump to start of program
        .dw     0
        .dw     title                           ; Pointer to program description for shells
title:
.db     "Alien Breed IV: Final Assault",0       ; Description
#endif

;------------------------------------------------
; Other Generic Defines, Includes, etc.
;------------------------------------------------
#define TIMES8(reg) add reg,reg \ add reg,reg \ add reg,reg
#define PUT_ALIGNED_SPRITE                      ; Include putAlignedSprite routine
#define PUT_CLIPPED_SPRITE                      ; Include putClippedSprite routine
#define PUT_CLIPPED_MASKED_SPRITE               ; Include putClippedMaskedSprite routine
#define RIGHT_CLIP 96
#include "get_key.inc"                          ; GET_KEY equates
#include "directin.inc"                         ; Direct Input equates

NUM_ALIEN_HOLES         = 10
NUM_ANIMS               = 5
NUM_BULLETS             = 12
NUM_ENEMIES             = 15
NUM_SECURITY_GUARDS     = 5
PICKUP_TILE             = 54
AUTO_DESTRUCT_TILE      = 64
VFIRE_DOOR_TILE         = 65
HFIRE_DOOR_TILE         = 66
AIR_DUCT_TILE           = 67
BOMB_TILE               = 68
UNOPEN_ALIEN_HOLE_TILE  = 69
OPEN_ALIEN_HOLE_TILE    = 70
TRIGGER_TILE            = 71
SECURITY_GUARD_TILE     = 75
QUEEN1_TILE             = 82
QUEEN2_TILE             = 83
QUEEN3_TILE             = 84
ENERGY_SHIELD           = 85
SOLID_TILE              = 89
TRIGGERED_BOMB_TILE     = 160
INTEX_TILE              = 161
EGG_TILE                = 162
POWER_DOME_TILE         = 164
NORMAL_DOOR             = 168
SECURITY_DOOR           = 170
WHITE_DOOR              = 172
CHECKERED_DOOR          = 174
BLACK_DOOR              = 176
OPEN_NORMAL_DOOR        = 92
OPEN_SECURITY_DOOR      = 92
OPEN_WHITE_DOOR         = 92
OPEN_CHECKERED_DOOR     = 94
OPEN_BLACK_DOOR         = 96
ANIM_NORMAL_DOOR        = 74
ANIM_SECURITY_DOOR      = 74
ANIM_COLORED_DOOR       = 74
CLOSE_FIRE_DOOR         = 101

QUEEN_STRENGTH          = 50

#ifdef ION
apdable                 = 2
apdrunning              = 3
apdflags                = 8
#endif
#ifdef TI86
apdrunning              = apdlock
#endif
#ifdef TI83
timer                   = $8009
#endif
#ifdef PLUS
timer                   = $8448
#endif
#ifdef TI86
timer                   = $C009
#endif

#ifndef TI86
DI_F1                   = DI_Y
DI_F2                   = DI_WINDOW
DI_F3                   = DI_ZOOM
DI_F4                   = DI_TRACE
DI_F5                   = DI_GRAPH
#endif

.end
