;-----------------------------------------------------------;
;                                                           ;
; Alien Breed IV: Final Assault                             ;
; Variables                                                 ;
;                                                           ;
;-----------------------------------------------------------;

;------------------------------------------------------------------------------
; Variable Name                  Location       Size    Description
;------------------------------------------------------------------------------
menuItem                        = vars+000      ; 1     Selected menu item
vatPtr                          = vars+001      ; 2     Pointer to next VAT entry
numLevelsets                    = vars+003      ; 1     Counter for number of Levelsets found
levelsetName                    = vars+004      ; 4     Name of current Levelset
dataPtr                         = vars+008      ; 2     Pointer to start of Levelset file
numLevels                       = vars+010      ; 1     Number of levels in current Levelset
hiScore                         = vars+011      ; 2     HiScore for current Levelset
stringBuffer                    = vars+013      ; 6     String buffer
level                           = vars+019      ; 1     Current level
levelData                       = vars+020      ; 16    Header data for current level
dead                            = vars+036      ; 1     Death spin counter
invincible                      = vars+037      ; 1     Invincibility counter
hurt                            = vars+038      ; 1     Flag for if player is being hurt
weapon                          = vars+039      ; 1     Current weapon player is using
frame                           = vars+040      ; 1     Frame counter
scrX                            = vars+041      ; 1     X Coord of top-left pixel on screen
scrY                            = vars+042      ; 1     Y Coord of top-left pixel on screen
tempX                           = vars+043      ; 1     Temp storage
tempY                           = vars+044      ; 1     Temp storage
scrollBits                      = vars+045      ; 1     Used in scrolling routines
scrollSkip                      = vars+046      ; 2     Used in scrolling routines
scrollMask                      = vars+048      ; 1     Used in scrolling routines
scrollPointer                   = vars+049      ; 2     Used in scrolling routines
playerDir                       = vars+051      ; 1     Player direction
ammo                            = vars+052      ; 2     Ammo for player
keyPasses                       = vars+054      ; 1     Number of Key Passes player has
health                          = vars+055      ; 1     Player Health
lives                           = vars+056      ; 1     Number of lives player has
credits                         = vars+057      ; 2     Amount of credits player has
score                           = vars+059      ; 2     Players score
weaponTable                     = vars+061      ; 5     Which weapons player has
keyTable                        = vars+066      ; 3     Which colored keys player has
radarScanner                    = vars+069      ; 1     Flag for if the player owns a Radar Scanner
passcodePtr                     = vars+070      ; 2     Pointer to start of passcodes
queen                           = vars+072      ; 1     Flag for if player is battling a Queen
animTable                       = vars+073      ; 20    Animations, 4 bytes * 5 entries (Type, Counter, X, Y)
bulletTable                     = vars+093      ; 48    Bullets, 4 bytes * 12 entries (Type, Direction, X, Y)
enemyTable                      = vars+141      ; 105   Enemies, 7 bytes * 15 entries (Type, Direction, X, Y, Counter, Energy, SpeedCnt)
collideObject1                  = vars+246      ; 4     Collision detection object 1
collideObject2                  = vars+250      ; 4     Collision detection object 2
intexSelection                  = vars+254      ; 1     Menu item selected in Intex Network System
intexOptions                    = vars+255      ; 1     Number of choices available in an Intex Menu
system                          = vars+256      ; 256   To store system pointers normally after gbuf
queenCnt                        = vars2+000     ; 1     Counter for Queen Alien
queenSprCnt                     = vars2+001     ; 1     Counter for which Queen sprite to show
queenDir                        = vars2+002     ; 1     Which direction Queen is moving (up or down)
queenSprPtr                     = vars2+003     ; 2     Pointer to start of Queen sprites
queenHealth                     = vars2+005     ; 2     Health of Queen Alien
qX                              = vars2+007     ; 1     Queen X Coord
qY                              = vars2+008     ; 1     Queen Y Coord
playerCenter                    = vars2+009     ; 2     Center of player
fireDoor                        = vars2+011     ; 2     Address in Level data of Fire Door
alienHoleTable                  = vars2+013     ; 30    Alien Holes, 3 bytes * 10 entries (Counter, X, Y)
securityGuardTable              = vars2+043     ; 10    Security Guards, 2 bytes * 5 entries (X, Y)
securityGuardCnt                = vars2+053     ; 1     Counter for Security Guards
securityGuardMissile            = vars2+054     ; 4     Single entry for Security Guard missile
temp                            = vars2+058     ; 18    Temp row used for scrolling

height                          = levelData+000 ; 1     Level height
width                           = levelData+001 ; 1     Level width
objectives                      = levelData+002 ; 1     Objectives counter
time                            = levelData+003 ; 1     Time left
blockPutX                       = levelData+004 ; 1     X Coord of block to put
blockPutY                       = levelData+005 ; 1     Y Coord of block to put
blockTakeX                      = levelData+006 ; 1     X Coord of block to take
blockTakeY                      = levelData+007 ; 1     Y Coord of block to take
blockPutType                    = levelData+008 ; 1     Block Put Type
blockTakeType                   = levelData+009 ; 1     Block Take Type
type                            = levelData+010 ; 1     Level type
alienType                       = levelData+011 ; 1     Alien type to come out of holes
finishX                         = levelData+012 ; 1     Finish X Coord
finishY                         = levelData+013 ; 1     Finish Y Coord
x                               = levelData+014 ; 1     X Coord
y                               = levelData+015 ; 1     Y Coord

.end
